/* 
    Threaded socket routines - include file for netsocket.c 

    Copyright (C) 1999/2000  A. Schiffler

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    To contact the author try these:
    |  Andreas Schiffler                    aschiffler@home.com  |
    |  Senior Systems Engineer    -    Deskplayer Inc., Buffalo  |
    |  4707 Eastwood Cres., Niagara Falls, Ont  L2E 1B4, Canada  |
    |  +1-905-371-3652 (private)  -  +1-905-371-8834 (work/fax)  |

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/select.h>
#include <fcntl.h>
#include <string.h>

#include <netinet/in.h>

#include <limits.h>
#include <netdb.h>
#include <arpa/inet.h>

#include <sys/socket.h>
#include <errno.h>

#include <pthread.h> 

#define BE_VERBOSE	1
#define SHUT_UP		0

struct netthread {
		pthread_t network_thread;
		pthread_mutex_t network_mutex;
		unsigned short port;
		int verbose;
		};

/* Empty prototype only - write this function externally! */

extern int command_to_output(char *inbuffer, char* outbuffer, int outbufferlen);

/* Prototypes */

int stop_network_socket(struct netthread *nt);
int start_network_socket(struct netthread *nt, 
			 unsigned short port,
			 int verbose);
int shared_data_lock(struct netthread *nt);
int shared_data_unlock(struct netthread *nt);
