#!/bin/sh

#
# libbgrab: sample module loader to enable BTTV video4linux modules
#

#
# ------- Edit tuner and card types before use.
#

# Tuners (kernel 2.2.15):
#
#    0: Temic PAL tuner
#    1: Philips PAL_I tuner
#    2: Philips NTSC tuner
#    3: Philips SECAM tuner
#    4: no tuner
#    5: Philips PAL tuner
#    6: Temic NTSC tuner
#    7: Temic PAL_I tuner
#    8: Temic 4036 FY5 NTSC tuner
#    9: Alps TSBH1 NTSC tuner
#   10: Alps TSBH1 PAL tuner
#

TUNER=2

# Cards (kernel 2.2.15):
#
#    0: Auto-Detect
#    1: Miro
#    2: Hauppauge
#    3: STB
#    4: Intel
#    5: Diamond DTV2000
#    6: AVerMedia TVPhone
#    7: Matrix Vision MV-Delta
#    8: Fly Video II
#    9: TurboTV
#   10: Newer Hauppauge (Bt878)
#   11: Miro PCTV Pro
#   12: ADS Tech Channel Surfer TV (and maybe TV+FM)
#   13: AVerMedia TVCapture 98
#   14: Aimslab VHX
#   15: Zoltrix TV-Max
#   16: Pixelview PlayTV (nt878)
#   17: Leadtek WinView 601
#   18: AVEC Intercapture
#   19: LifeView FlyKit (w/o Tuner)
#

CARD=0

# ---------------

if test "$UID" = "0"; then
 	# running as root anyway, don't need sudo
	INSMOD="/sbin/insmod"
	RMMOD="/sbin/rmmod"
else
	INSMOD="sudo /sbin/insmod"
	RMMOD="sudo /sbin/rmmod"
fi

# Handy functions for rmmod/insmod
function xrmmod () {
	grep -qe "^$1" /proc/modules || return
	echo rmmod $1
	$RMMOD $1 || exit 1
}

function xinsmod () {
	echo insmod $*
	$INSMOD -f $* || exit 1
}

# Be safe
sync; sleep 1; sync

# kill old modules ...
xrmmod bttv
xrmmod msp3400
xrmmod tda8425
xrmmod tea6300
xrmmod tuner
xrmmod i2c_chardev
xrmmod i2c-dev
xrmmod algo-bit
xrmmod i2c
xrmmod videodev

# ... and load the new ones
xinsmod videodev
xinsmod i2c		verbose=1 scan=1 i2c_debug=0
test -f i2c_chardev.o && xinsmod i2c_chardev
xinsmod tuner		debug=0 type=$TUNER
#
# Uncomment these as required
#
# xinsmod msp3400	debug=0 simple=0
# xinsmod tda8425
# xinsmod tea6300
xinsmod bttv		radio=0 card=$CARD

