/*
    include file for webcamsocket.c

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    To contact the author try these:
    |  Andreas Schiffler                    aschiffler@home.com  |
    |  Senior Systems Engineer    -    Deskplayer Inc., Buffalo  |
    |  4707 Eastwood Cres., Niagara Falls, Ont  L2E 1B4, Canada  |
    |  +1-905-371-3652 (private)  -  +1-905-371-8834 (work/fax)  |
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>

#include <netinet/in.h>

#include <limits.h>
#include <netdb.h>
#include <arpa/inet.h>

#include <sys/socket.h>
#include <errno.h>

#include <pthread.h> 

#define BUFFER_LEN	4096
#define LINE_LEN	1024

/* Transfer variables and shared data */

struct netthreads {
		 pthread_mutex_t network_mutex;
		 int connected_socket;
		 /* Application specific information */
		 void *fg;
		 int jpeggray;
		 int jpegquality;
		 int camimage;
		};

/* Prototypes */

struct in_addr *a_to_addr(char *address);

int init_network_socket(struct netthreads *nt);
int start_network_socket(struct netthreads *nt, int connected_socket); 

int shared_data_lock(struct netthreads *nt);
int shared_data_unlock(struct netthreads *nt);

