/*
    Include file: Defines xutil library - xutil.h

    The contents of this file are subject to the Mozilla Public
    License Version 1.1 (the "License"); you may not use this file
    except in compliance with the License. You may obtain a copy of
    the License at http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS
    IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
    implied. See the License for the specific language governing
    rights and limitations under the License.
   
    The Original Code is the libbgrab framegrabber library.
    
    The Initial Developer of the Original Code is A. Schiffler.  
    Portions created by A. Schiffler are Copyright (C) 1999-2000
    A. Schiffler.  All Rights Reserved.
    
    Contributor(s): Andreas Schiffler <aschiffler@home.com>
                                                                                                                dnl 
    Alternatively, the contents of this file may be used under the
    terms of the GNU General Public License Version 2 or later (the
    "GPL"), in which case the provisions of the GPL are applicable 
    instead of those above.  If you wish to allow use of your 
    version of this file only under the terms of the GPL and not to
    allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and
    replace them with the notice and other provisions required by
    the GPL.  If you do not delete the provisions above, a recipient
    may use your version of this file under either the MPL or the
    GPL.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    To contact the author try:
    |  Andreas Schiffler                    aschiffler@home.com  |
    |  Senior Systems Engineer  -  Deskplayer.Com Inc., Buffalo  |
    |  4707 Eastwood Cres., Niagara Falls, Ont  L2E 1B4, Canada  |
    |  +1-905-371-3652 (private)  -  +1-905-371-8834 (work/fax)  |

*/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>

#include <sys/shm.h>
#include <sys/ipc.h>

struct xwinbuffer {
	int width;
	int height;
	int maxx,maxy;
	int depth;
	Display* display_;
	GC gc_;
	Window wtwin_;
	XImage *shmimage;
	XShmSegmentInfo* shminfo;
        int vm_count,vm_smode, modeswitch;
        XF86VidModeModeInfo **vm_modelines;
      };


/* Prototypes */

#ifdef __cplusplus
extern "C"
{
#endif

int setup_xwinbuffer(struct xwinbuffer *xwin, const char *prgname, int width, int height, int depth);
int sync_xwinbuffer(struct xwinbuffer *xwin);
int keypoll_xwinbuffer (struct xwinbuffer *xwin, KeySym *key, int *button, int *mousex, int *mousey);
int close_xwinbuffer (struct xwinbuffer *xwin);

void hline (struct xwinbuffer *xwin, int x1, int x2, int y, unsigned int color);
void vline (struct xwinbuffer *xwin, int x, int y1, int y2, unsigned int color);
void drawchar (struct xwinbuffer *xwin, int x, int y, const char c, unsigned int color);
void drawstring (struct xwinbuffer *xwin, int x, int y, const char *s, unsigned int color);
void drawpixel(struct xwinbuffer *xwin, int x, int y, unsigned int color);
void drawline(struct xwinbuffer *xwin, int x1, int y1, int x2, int y2, unsigned int color);
void drawbox (struct xwinbuffer *xwin, int x1, int y1, int x2, int y2, unsigned int color);

void videoModeChange(struct xwinbuffer *xwin, int width, int height);
void videoModeReset(struct xwinbuffer *xwin);

#ifdef __cplusplus
}
#endif
